var fs = require('fs')
var book = require('topsin.excelxs')
var db = require('topsin.database');
var crypto = require('topsin.crypto')
// 读取配置文件
var config = JSON.parse(fs.readFile('./config.json'))

// 主
function Main(props){
    // 执行初始化
    this.init()
}
// 初始化方法
Main.prototype.init = function(){
    console.log('init')
    this.dirlist = this.readDir(config.dirPath, -1)  // 获取文件夹下的文件列表
    if(this.dirlist.length === 0){  // 没有文件就退出
        return
    }
    this.readXlsx(this.dirlist)
}
// 读取文件夹 获取xlsx
Main.prototype.readDir = function(path){
    return fs.listDir(path).filter(function(v){return v.completeSuffix === "XLSX"})
}
// 循环读取文件列表 
Main.prototype.readXlsx = function(list){
    var that = this
    list.forEach(function(v){
        // 读取
        that.excelxs(v.dir + '/' + v.name, v.name)
    })
}

// 读取excelxs
Main.prototype.excelxs = function(path,name){
    if(book.open(path)) {
        var sheet = book.getActiveSheet()  // 获取当前表
        if(sheet.isNull()){return}
        // 获取表字段数量
        var keysCount = sheet.getLastCol()
        // 获取数据数量
        var dataCount = sheet.getLastRow() - 1
        // 获取字段数组
        this.keys = []
        for(var i=0;i<keysCount;i++){
            this.keys.push(config.dataKeys[crypto.md5(sheet.getCellValue(0, i))].dbkey)
        }
        var datalist = []  // 定义数组 两次循环获取表数据
        for(var j = 1,length = sheet.getLastRow();j<length;j++){
            datalist[j-1] = {}
            for(var i = 0;i<keysCount;i++){
                if(i ===5 || i===6){
                    // var formatdate = sheet.getCellFormat(j, i)
                    datalist[j-1][config.dataKeys[crypto.md5(sheet.getCellValue(0, i))].dbkey] = sheet.getCellValue(j, i)
                } else {
                    datalist[j-1][config.dataKeys[crypto.md5(sheet.getCellValue(0, i))].dbkey] = sheet.getCellValue(j, i)
                }
            }
        }
        // 数据处理
        this.paytionType({
            keysCount:keysCount,
            datalist:datalist
        })
        book.saveAs(config.rdir + '/' + name)  // 读取完的文件另存为 然后可以删除
        // 删除
        // fs.unlink(path)
    }
}
Main.prototype.paytionType = function(props){  // 处理数据
    db.addConnection(config.dbconfig, "Scott_PMO_TRAINING");  // 连接数据库
    this.tablename = 'sec_production_order_confirmation_2'  // 设置数据库表名
    this.query = db.query('Scott_PMO_TRAINING');  // 获取操作对象
    var dbDatas = getDbData(this.query,this.tablename)  // 获取数据库的所有数据
    console.log(dbDatas.length);
    
    if(!dbDatas){return}
    if(props.keysCount <= Object.keys(config.dataKeys).length){ // 当字段数量小于等于配置文件字段数量时候 只新增
        var res = filterOldData(props.datalist,dbDatas)  // 数据过滤
        var newData = res.newData
        this.insertAny(newData)
    } else {
        console.log('要对字段扩展')
        // this.UpdateKeys()
    }

    db.removeConnection('Scott_PMO_TRAINING');  // 移除数据库操作
}
Main.prototype.insertAny = function(datas){ // 批量插入数据
    this.query.begin()
    try{
        this.query.batchInsert(
            this.tablename,
            this.keys,
            datas
        );
        if (this.query.lastError().isValid()){
            throw this.query.lastError().text();
        }
        this.query.commit();
    }
    catch(err) {
        console.log("插入数据错误")
        console.log(err)
        this.query.rollback();
    }
}
function getDbData(query,tablename){   // 获取数据库所有数据
    query.begin()
    var data;
    try {
        data = query.selectArrayMap({
            table: tablename,
            field: '*',
            field_format:{"tags":'array', attr_data:'json'}
        })
        if (query.lastError().isValid()){
            throw query.lastError().text();
        }
        query.commit();
    } catch (error) {
        console.log("获取数据库数据错误")
        console.log(error)
        query.rollback();
        // data = false;
    }
    return data
}
// key过滤  根据唯一的key将数据分为两组 一组是新数据 一组是原来的数据
function filterOldData(datas,dbdatas, keys){
    // 获取dbdata的唯一字段列表
    dbI = dbdatas.map(function(v){
        var tempStr = ""
        tempStr += v["order_no"] + v["confirmation"] + v["plant","material"] + v["material_description"] + v["posting_date"] + v["confirmation_entry_time"]
        return tempStr
    })
    var oldData = [],
        newData = [];
    for(var i = 0,len=datas.length;i<len;i++){
        var v = datas[i]
        var dataI = v["order_no"] + v["confirmation"] + v["plant","material"] + v["material_description"] + v["posting_date"] + v["confirmation_entry_time"]
        if(dbI.indexOf(dataI) > 0){
            // 老数据
            oldData.push(v)
        } else{
            // 新数据
            newData.push(v)
        }
    }
    return {
        oldData:oldData,
        newData:newData
    }
}

function configReset(){
    config.isUseing = false
    fs.writeFile('./config.json',JSON.stringify(config)) // 覆盖写入json
}

if(!config.isUseing){  // 如果没在运行程序就可以实例化
    config.isUseing = true
    fs.writeFile('./config.json',JSON.stringify(config)) // 覆盖写入json
    var demo = new Main()
    
    book.close()
    configReset()  // json变成未使用状态
}



// ["attr_data","action_data","extra_data","tags","sys_tags","sys_data"]

